# Contributing

If you'd like to contribute code: Awesome.
There's just 2 very short requirements.

## Rule #1

The code must be yours.

It's simple:

- Do not take code that is by anyone else that is not you.


## Rule #2

No submission or decompilation of third-party code. This is important if you want to recreate behaviour from another game.

- We do not decompile. We reverse-engineer by trial and error.

This is generally referred to as 'clean-room engineering'.
Most of the behaviour is rather predictable, other is not.

This is why some of the parts of Nuclide, which emulate entities/frameworks
from other games may feel a bit off. It's because it's all implemented by eye.

# Other notes

Game specific features need to be put into game-specific directories.

Unless other games benefit from this, keep it seperate to one of the game
sub-directories. This usually means it'll be part of another git repository too.

That's about it!

# Saying Thanks

If you want to solely say thanks, the main developer of Nuclide **loves** receiving E-Mail. You can contact him at <mailto:marco@vera-visions.com> and let him know your thoughts.

If you'd like to donate to him via [PayPal](https://paypal.me/eukara) or [Patreon](https://www.patreon.com/eukara) you can do that too. That money pays for a lot of free services he provides that come with both [FTEQW](https://www.fteqw.org/) and **Nuclide**.